Attribute VB_Name = "Main"
Option Explicit

Global Const resource_offset_DE = 0
Global Const resource_offset_EN = 1000
Global offset_language As Integer
Global Const FileExtension = ".LWP"
Global Const TextProcessor = "WordPro"

Sub Main()
    ' Determine language of OS (reading registry)
    Call GetCurrentLanguage

    ' Load texts from resource file
    Call LoadLanguageResource(offset_language)
End Sub
Sub GetCurrentLanguage()
    ' Read value in Windows registry that tells as under what language the OS runs
    ' we are going to use that language or english as an default if key does not exist or is not german
    Dim ret_value As Variant
    If GetValue(HKEY_CURRENT_USER, "Control Panel\International", "sLanguage", ret_value) Then
        If Left$(ret_value, 3) = "DEU" Then
            offset_language = resource_offset_DE
        Else
            offset_language = resource_offset_EN
        End If
    Else
        offset_language = resource_offset_EN
    End If

End Sub

Sub LoadLanguageResource(ByVal offset&)

    Dim f As Form
    Dim c As Control
    
    For Each f In Forms
        For Each c In f.Controls
            If c.Tag <> "" Then c.Caption = LoadResString(CInt(c.Tag) + offset)
        Next c
    Next f

End Sub
