Attribute VB_Name = "UtilsModule"
Option Explicit
Const resource_offset_DE = 0
Const resource_offset_EN = 1000

Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Declare Function OpenProcess Lib "kernel32" (ByVal dwDesiredAccess As Long, ByVal bInheritHandle As Long, ByVal dwProcessId As Long) As Long
Declare Function GetExitCodeProcess Lib "kernel32" (ByVal hProcess As Long, lpExitCode As Long) As Long
Global Const STILL_ACTIVE = &H103
Global Const PROCESS_QUERY_INFORMATION = &H400


Sub LoadLanguage(f As Form)
    Dim cl As Integer
    cl = currentLanguage
    
    Dim c As Control
    For Each c In f.Controls
        If c.Tag <> "" Then c.Caption = LoadResString(CInt(c.Tag) + cl)
    Next c
    
    If f.Name = "Form1" Then
        Form1.Caption = LoadResString(CInt(13) + cl)
    End If
    
    If f.Name = "Form2" Then
        Form1.Caption = LoadResString(CInt(15) + cl)
    End If
    
End Sub

Function currentLanguage() As Integer
    ' Read value in Windows registry that tells as under what language the OS runs
    ' we are going to use that language or english as an default if key does not exist or is not german
    Dim ret_value As Variant
    If GetValue(HKEY_CURRENT_USER, "Control Panel\International", "sLanguage", ret_value) Then
        If Left$(ret_value, 3) = "DEU" Then
            currentLanguage = resource_offset_DE
        Else
            currentLanguage = resource_offset_EN
        End If
    Else
        currentLanguage = resource_offset_EN
    End If

    '    currentLanguage = resource_offset_EN
End Function

Function getDirectoryList(DirPath As String, fileExt As String, Attrib As Integer)
    Dim tempfile, shellc, i
    Dim filelist() As String
    Dim hTask As Long
    Dim hProcess As Long
    Dim exitCode As Long
    
    i = 0

    tempfile = App.Path & "\directory.tmp"
    If Dir$(tempfile, vbNormal) <> "" Then
        Kill tempfile
    End If
    
    shellc = "cmd.exe /c dir/s/b " & DirPath & "\" & fileExt & " >" & Chr(34) & tempfile & Chr(34)
    hTask = Shell(shellc, vbHide)
    hProcess = OpenProcess(PROCESS_QUERY_INFORMATION, False, hTask)
        
    ' We do need to wait for the process to be ended
    Do
        Sleep 100
        DoEvents
        GetExitCodeProcess hProcess, exitCode
    Loop While exitCode = STILL_ACTIVE
        
    If Dir$(tempfile, vbNormal) <> "" Then
        Open tempfile For Input As #3
        i = 0
        While Not EOF(3)
            i = i + 1
            ReDim Preserve filelist(1 To i)
            Line Input #3, filelist(i)
        Wend
        Close 3
        Kill tempfile
    End If

    If i = 0 Then
        getDirectoryList = False
    Else
        getDirectoryList = filelist()
    End If
End Function

Public Sub KillWords()
    KillProcess "wordpro.exe"
    KillProcess "winword.exe"
End Sub

Public Function KillProcess(ByVal sProcessName As String)

 Dim oProcessCollection
 Dim oProcess
 
 ' Retrieve a list of all running process on the local machine
 Set oProcessCollection = GetObject("winmgmts:").ExecQuery("SELECT * FROM Win32_Process")
 
 ' Loop thru each instance of the specified
 ' executable program name and then end it.
 For Each oProcess In oProcessCollection
   If LCase(oProcess.Name) = LCase(sProcessName) Then
      oProcess.Terminate
   End If
 Next

End Function

Public Function logging(s As String, Optional init As Boolean = False)
    Dim tempfile, month_out, version_out, t As String
    
    If Left$(Date$, 2) = "01" Then month_out = "Jan"
    If Left$(Date$, 2) = "02" Then month_out = "Feb"
    If Left$(Date$, 2) = "03" Then month_out = "Mar"
    If Left$(Date$, 2) = "04" Then month_out = "Apr"
    If Left$(Date$, 2) = "05" Then month_out = "May"
    If Left$(Date$, 2) = "06" Then month_out = "Jun"
    If Left$(Date$, 2) = "07" Then month_out = "Jul"
    If Left$(Date$, 2) = "08" Then month_out = "Aug"
    If Left$(Date$, 2) = "09" Then month_out = "Sep"
    If Left$(Date$, 2) = "10" Then month_out = "Oct"
    If Left$(Date$, 2) = "11" Then month_out = "Nov"
    If Left$(Date$, 2) = "12" Then month_out = "Dec"
    t = Mid$(Date$, 4, 2) + "-" + month_out + "-" + Right$(Date$, 4) + " " + Time$ + " "
    s = t + s
        
    If init Then
        tempfile = App.Path & "\" & TextProcessor & "proconvlast.log"
        If Dir$(tempfile, vbNormal) <> "" Then
            Kill tempfile
        End If
        version_out = t + "GNU/GPL Version " & App.Major & "." & App.Minor
    End If
    
    Open TextProcessor & "proconv.log" For Append As #1
    Open TextProcessor & "proconvlast.log" For Append As #2
        
    Write #1, s
    Write #2, s
    
    If init Then
       Write #1, version_out
       Write #2, version_out
    End If
    
    Close 1, 2
    
End Function
